HorizonIndicator = HorizonIndicator or {}
do 
	local save_path = SavePath
	local mod_path = ModPath
	if HorizonIndicatorCore then 
		mod_path = HorizonIndicatorCore:GetPath()
	end
	HorizonIndicator._mod_path = mod_path
	HorizonIndicator._menu_path = mod_path .. "menu/options.json"
	HorizonIndicator._default_localization_path = mod_path .. "localization/english.json"
	HorizonIndicator._save_file_name = "horizon_indicator.ini"
	HorizonIndicator._save_path = save_path .. HorizonIndicator._save_file_name
	
	HorizonIndicator.whitelisted_heists = {
		safehouse = false, --The safe house
		short = false, --The Tutorial Heists
		cane = false, --Santa's Workshop
		brb = false, --Brooklyn Bank
		short1 = false, --Flash Drive - Stealth
		short2 = false, --Get The Coke - Loud
		haunted = false, --Safe house Nightmare
		jewelry_store = false, --Jewelry Store
		family = false, --Diamond Store
		mallcrasher = false, --Mallcrasher
		ukrainian_job_prof = false, --Ukrainian Job
		four_stores = false, --Four Stores
		gallery = false, --Art Gallery
		ukrainian_job = false, --Ukrainian Job
		hvh = false, --Cursed Kill Room
		help = false, --Prison Nightmare
		branchbank = false, --Bank Heist: Random
		vit = false, --The White House
		wwh = false, --Alaskan Deal
		chill_combat = false, --Safe House Raid
		pex = false, --Breakfast in Tijuana
		fex = false, --Buluc's Mansion
		mex = false, --Border Crossing
		bph = false, --Hell's Island
		branchbank_cash = false, --Bank Heist: Cash
		dah = false, --Diamond Heist
		chca = false, --Black Cat
		flat = false, --Panic Room
		moon = false, --Stealing Xmas
		pent = false, --Mountain Master
		arm_fac = false, --Transport: Harbor
		pbr = false, --Beneath the Mountain
		chill = false, --Safe House
		dinner = false, --Slaughterhouse
		peta = false, --Goat Simulator
		branchbank_gold_prof = false, --Bank Heist: Gold
		man = false, --Undercover
		nightclub = false, --Nightclub
		fish = false, --The Yacht Heist
		arm_par = false, --Transport: Park
		friend = false, --Scarface Mansion
		nmh = false, --No Mercy
		arm_cro = false, --Transport: Crossroads
		kosugi = false, --Shadow Raid
		born = false, --The Biker Heist
		branchbank_deposit = false, --Bank Heist: Deposit
		sah = false, --Shacklethorne Auction
		dark = false, --Murky Station
		arm_hcm = false, --Transport: Downtown
		nail = false, --Lab Rats
		cage = false, --Car Shop
		spa = false, --Brooklyn 10-10
		branchbank_gold = false, --Bank Heist: Gold
		arm_und = false, --Transport: Underpass
		des = false, --Henry's Rock
		shoutout_raid = false, --Meltdown
		pal = false, --Counterfeit
		mex_cooking = false, --Border Crystals
		tag = false, --Breakin' Feds
		pbr2 = false, --Birth of Sky
		sand = false, --The Ukrainian Prisoner
		ranc = false, --Midland Ranch
		jolly = false, --Aftershock
		chas = false, --Dragon Heist
		bex = false, --San Mart├¡n Bank
		branchbank_prof = false, --Bank Heist: Random
		mad = false, --Boiling Point
		alex = false, --Rats
		roberts = false, --GO Bank
		hox_3 = false, --Hoxton Revenge
		election_day = false, --Election Day
		pines = false, --White Xmas
		mus = false, --The Diamond
		watchdogs_wrapper = false, --Watchdogs
		firestarter = false, --Firestarter
		run = false, --Heat Street
		welcome_to_the_jungle_wrapper = false, --Big Oil
		glace = false, --Green Bridge
		skm_mus = false, --The Diamond
		framing_frame = false, --Framing Frame
		modders_devmap = false, --Proving Grounds
		arena = false, --The Alesso Heist
		mia = false, --Hotline Miami
		red2 = false, --First World Bank
		skm_big2 = false, --The Big Bank
		skm_arena = false, --The Alesso Heist
		rvd = false, --Reservoir Dogs Heist
		skm_red2 = false, --First World Bank
		skm_run = false, --Heat Street
		skm_bex = false, --San Martin Bank
		hox = false, --Hoxton Breakout
		crojob1 = false, --The Bomb: Dockyard
		skm_watchdogs_stage2 = false, --Boat Load
		rat = false, --Cook Off
		big = false, --The Big Bank
		crojob_wrapper = true, --The Bomb: Forest
		skm_cas = false, --Golden Grin Casino
		skm_mallcrasher = false, --Mallcrasher
		kenaz = false, --Golden Grin Casino
		arm_for = false, --Transport: Train Heist
		welcome_to_the_jungle_wrapper_prof = false --Big Oil
	}
	HorizonIndicator.default_settings = {
		master_enabled = true,
		heist_whitelist_enabled = true,
		
		horizon_enabled = true,
		horizon_w = 300,
		horizon_h = 2,
		horizon_alpha = 0.9,
		horizon_color = "ffffff",
		horizon_layer = 1,
		horizon_distance_scalar = 2, --how fast/how far the horizon indicator moves when looking up/down
		horizon_angle_scalar = 90, --the maximum pitch angle in calculations
		horizon_upper_y_margin = -1, --the effective screen space's ceiling for the horizon indicator (from the top of the screen); leave -1 for no floor
		horizon_lower_y_margin = -1, --the effective screen space's floor for the horizon indicator (from the bottom of the screen); leave -1 for no ceiling
		
		tangent_enabled = true,
		tangent_w = 100,
		tangent_h = 5,
		tangent_alpha = 0.25,
		tangent_color = "1F85DE",
		tangent_layer = 2,
		tangent_offset_x = 0,
		tangent_offset_y = 0,
		tangent_ground_ray_distance = 300, --cm down to check for ground beneath the player (3m default)
		tangent_angle_scalar = 90
	}
	HorizonIndicator.settings_sort = {
		"master_enabled",
		"heist_whitelist_enabled",
		
		"horizon_enabled",
		"horizon_w",
		"horizon_h",
		"horizon_alpha",
		"horizon_color",
		"horizon_layer",
		"horizon_distance_scalar",
		"horizon_angle_scalar",
		"horizon_upper_y_margin",
		"horizon_lower_y_margin",

		"tangent_enabled",
		"tangent_w",
		"tangent_h",
		"tangent_alpha",
		"tangent_color",
		"tangent_layer",
		"tangent_offset_x",
		"tangent_offset_y",
		"tangent_ground_ray_distance",
		"tangent_angle_scalar"
	}
	HorizonIndicator.settings = table.deep_map_copy(HorizonIndicator.default_settings)
end

do
	--load ini parser
	local f,e = blt.vm.loadfile(HorizonIndicator._mod_path .. "utils/LIP.lua")
	local lip
	if e then 
		log("[Horizon Indicator in HUD] ERROR: Failed loading LIP module. Try re-installing BeardLib if this error persists.")
	elseif f then 
		lip = f()
	end
	if lip then 
		HorizonIndicator._lip = lip
	end
end

function HorizonIndicator:SaveSettings()
	if self._lip then
		self._lip.save(self._save_path,{Config = self.settings,Heists=self.whitelisted_heists},self.settings_sort)
	end
end

function HorizonIndicator:LoadSettings()
	if self._lip then 
		if SystemFS:exists( Application:nice_path(self._save_path,true) ) then 
			local config_from_ini = self._lip.load(self._save_path)
			if config_from_ini then 
				if config_from_ini.Config then 
					for k,v in pairs(config_from_ini.Config) do
						self.settings[k] = v
					end
				end
				if config_from_ini.Heists then
					for k,v in pairs(config_from_ini.Heists) do 
						self.whitelisted_heists[k] = v
					end
				end
			end
		else
			self:SaveSettings()
		end
	end
end

function HorizonIndicator:CreateHUD()
	if not managers.hud then 
		return
	end
	
	local settings = self.settings
	local enabled = settings.master_enabled
	
	if settings.heist_whitelist_enabled then
		local job_id = managers.job:current_real_job_id()
		if not (job_id and self.whitelisted_heists[job_id]) then 
			enabled = false
		end
	end
	
	local horizon_panel = self._panel
	if alive(horizon_panel) then 
		hud:remove(horizon_panel)
		horizon_panel = nil
		self._panel = nil
	end
	
	local parent_hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
	if parent_hud and parent_hud.panel then 
		hud = parent_hud.panel
	else
		hud = managers.hud._workspace and managers.hud._workspace:panel()
	end
	
	if not hud then 
		log("[Horizon Indicator in HUD] I dunno what kinda hecked-up HUD mods you have but you gotta look into that chief, I can't work like this")
	end
	
	
	horizon_panel = hud:panel({
		name = "horizon_panel",
		visible = enabled
	})
	self._panel = horizon_panel
	local horizon_w = settings.horizon_w
	local horizon_h = settings.horizon_h
	
	local tangent_w = settings.tangent_w
	local tangent_h = settings.tangent_h
	
	local horizon_line = horizon_panel:rect({
		name = "horizon_line",
		color = Color(settings.horizon_color),
		w = horizon_w,
		h = horizon_h,
		x = (horizon_panel:w() - horizon_w) / 2,
		y = (horizon_panel:h() - horizon_h) / 2,
		alpha = settings.horizon_alpha,
		visible = settings.horizon_enabled,
		layer = settings.horizon_layer
	})
	
	local tangent_line = horizon_panel:rect({
		name = "tangent_line",
		color = Color(settings.tangent_color),
		w = tangent_w,
		h = tangent_h,
		x = (horizon_panel:w() - tangent_w) / 2,
		y = (horizon_panel:h() - tangent_h) / 2,
		alpha = settings.tangent_alpha,
		visible = settings.tangent_enabled,
		layer = settings.tangent_layer
	})
	
	local dot = horizon_panel:rect({
		name = "dot",
		w = 5,
		h = 5,
		visible = false,
		color = Color.red,
		alpha = 0.7,
		layer = 5
	})
	local vertical_line = horizon_panel:rect({
		name = "vertical_line",
		w = 4,
		h = 1000,
		visible = false,
		alpha = 0.25
	})
	
	if enabled then
		managers.hud:add_updator("horizonindicator_updatehud",callback(self,self,"Update"))
	end
end

function HorizonIndicator:Update(t,dt)
	local settings = self.settings
	local horizon_enabled = settings.horizon_enabled
	local tangent_enabled = settings.tangent_enabled
	
	local player = managers.player:local_player()
	local vm = managers.viewport
	local viewport_cam = vm:get_current_camera()
	if alive(player) and viewport_cam then 
		local panel = self._panel
		if alive(panel) then
			self._panel:show()
--			local cam_pos = vm:get_current_camera_position()
			local cam_rot = player:camera():rotation() --vm:get_current_camera_rotation()
			local pitch = cam_rot:pitch()
			local roll = cam_rot:roll()
			local center_x,center_y = panel:center()
			local panel_w = panel:w()
			local panel_h = panel:h()
			local horizon_line = panel:child("horizon_line")
			
			if settings.horizon_enabled then
				local horizon_upper_y_margin = settings.horizon_upper_y_margin
				local horizon_lower_y_margin = settings.horizon_lower_y_margin
				local horizon_angle_scalar = settings.horizon_angle_scalar
				local horizon_distance_scalar = settings.horizon_distance_scalar
				local hud_center_x = (panel_w - horizon_line:w()) / 2
				local hud_center_y = (panel_h - horizon_line:h()) / 2
				local pitch_nrm = (pitch / horizon_angle_scalar) * horizon_distance_scalar
				local horizon_y = hud_center_y * (1 + pitch_nrm)
				
				
				--horizon line screen bounding
				if horizon_lower_y_margin >= 0 then
					local horizon_lower_y = panel_h - horizon_lower_y_margin
					if horizon_upper_y_margin >= 0 then
						horizon_y = math.clamp(horizon_y,horizon_upper_y_margin,horizon_lower_y)
					else
						horizon_y = math.min(horizon_y,horizon_lower_y)
					end
				elseif horizon_upper_y_margin >= 0 then
					horizon_y = math.max(horizon_y,horizon_upper_y_margin)
				end
				
				horizon_line:set_y(horizon_y)
				
				horizon_line:set_center_x(center_x * (1 + (math.sin(roll) * pitch/horizon_angle_scalar)))
				horizon_line:set_rotation(-roll)
				
			end
			
--			panel:child("dot"):set_center_x(center_x * (1 + (math.sin(roll) * pitch/horizon_angle_scalar)))
--			panel:child("dot"):set_center_y(hud_center_y * (1 + pitch_nrm))
--			panel:child("vertical_line"):set_rotation(-roll)
--			panel:child("vertical_line"):set_center(center_x,center_y)
			
			if settings.tangent_enabled then
				local tangent_line = panel:child("tangent_line")
				--poll nearby landscape
				local from_pos = player:camera():position() --player:movement():m_pos()
				local ground_ray_distance = settings.tangent_ground_ray_distance
				local to_pos = from_pos + Vector3(0,0,-ground_ray_distance)
				local ground_ray = World:raycast("ray",from_pos,to_pos,"slot_mask",managers.slot:get_mask("world_geometry"))
				if ground_ray then 
				
					local tangent_offset_x = settings.tangent_offset_x
					local tangent_offset_y = settings.tangent_offset_y
					
					local tangent_angle_scalar = settings.tangent_angle_scalar
					
					local normal = ground_ray.normal
					local fwd_dir = cam_rot:y() --forward direction
					
					local ground_cross = normal:cross(fwd_dir)
					
					local landscape_angle = ground_cross.z * tangent_angle_scalar

--[[					
					Draw:brush(Color.red):line(from_pos,from_pos + (normal * 500))
					Draw:brush(Color.green):line(from_pos,from_pos + (fwd_dir * 500))
					Draw:brush(Color.blue):line(from_pos,from_pos + (ground_cross * 500))
					
--					Console:SetTrackerValue("trackera",string.format("x: %0.2f",ground_cross.x))
--					Console:SetTrackerValue("trackerb",string.format("y: %0.2f",ground_cross.y))
--					Console:SetTrackerValue("trackerc",string.format("z: %0.2f",ground_cross.z))
--]]
					
					tangent_line:set_rotation(landscape_angle - roll)
					tangent_line:set_center(center_x + tangent_offset_x,center_y + tangent_offset_y)
					
					tangent_line:set_visible(true)
				else
					tangent_line:hide()
				end
			end
			
			
		end
	else
		self._panel:hide()
	end
end

function HorizonIndicator:EnableMod()
	if managers.hud then
		managers.hud:add_updator("horizonindicator_updatehud",callback(self,self,"Update"))
	end
	if alive(HorizonIndicator._panel) then 
		HorizonIndicator._panel:set_visible(true)
	end
end

function HorizonIndicator:DisableMod()
	if managers.hud then
		managers.hud:remove_updator("horizonindicator_updatehud")
	end
	if alive(HorizonIndicator._panel) then 
		HorizonIndicator._panel:set_visible(false)
	end
end

function HorizonIndicator:CheckModEnabled()
	local master_enabled = self.settings.master_enabled
	local heist_whitelist_enabled = self.settings.heist_whitelist_enabled
	if master_enabled then 
		if heist_whitelist_enabled then
			local job_id = managers.job:current_real_job_id()
			if job_id and self.whitelisted_heists[job_id] then 
				self:EnableMod()
			else
				self:DisableMod()
			end
		else
			self:EnableMod()
		end	
	else
		self:DisableMod()
	end
end

Hooks:Add("LocalizationManagerPostInit", "horizonindicator_LocalizationManagerPostInit", function( loc )
	if not BeardLib then
		loc:load_localization_file( HorizonIndicator._default_localization_path)
	end
end)

Hooks:Add( "MenuManagerInitialize", "horizonindicator_MenuManagerInitialize", function(menu_manager)
	
	MenuCallbackHandler.callback_horizonindicator_master_enabled = function(self,item)
		local value = item:value() == "on"
		HorizonIndicator.settings.master_enabled = value
		HorizonIndicator:CheckModEnabled()
		HorizonIndicator:SaveSettings()
	end
	
	MenuCallbackHandler.callback_horizonindicator_horizon_enabled = function(self,item)
		local value = item:value() == "on"
		HorizonIndicator.settings.horizon_enabled = value
		HorizonIndicator:SaveSettings()
		
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("horizon_line"):set_visible(value)
		end
	end
	
	MenuCallbackHandler.callback_horizonindicator_heist_whitelist_enabled = function(self,item)
		local value = item:value() == "on"
		HorizonIndicator.settings.heist_whitelist_enabled = value
		HorizonIndicator:CheckModEnabled()
		HorizonIndicator:SaveSettings()
		
	end
	
	MenuCallbackHandler.callback_horizonindicator_horizon_w = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.horizon_w = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("horizon_line"):set_w(value)
		end
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_horizonindicator_horizon_h = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.horizon_h = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("horizon_line"):set_h(value)
		end
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_horizonindicator_horizon_alpha = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.horizon_alpha = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("horizon_line"):set_alpha(value)
		end
		HorizonIndicator:SaveSettings()
	end
	
	MenuCallbackHandler.callback_horizonindicator_tangent_enabled = function(self,item)
		local value = item:value() == "on"
		HorizonIndicator.settings.tangent_enabled = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("tangent_line"):set_visible(value)
		end
		HorizonIndicator:SaveSettings()
	end
	
	MenuCallbackHandler.callback_horizonindicator_tangent_w = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.tangent_w = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("tangent_line"):set_w(value)
		end
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_horizonindicator_tangent_h = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.tangent_h = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("tangent_line"):set_h(value)
		end
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_horizonindicator_tangent_alpha = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.tangent_alpha = value
		if alive(HorizonIndicator._panel) then 
			HorizonIndicator._panel:child("tangent_line"):set_alpha(value)
		end
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_horizonindicator_tangent_offset_x = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.tangent_offset_x = value
		HorizonIndicator:SaveSettings()
	end
	MenuCallbackHandler.callback_offset_horizonindicator_tangent_offset_y = function(self,item)
		local value = tonumber(item:value())
		HorizonIndicator.settings.tangent_offset_y = value
		HorizonIndicator:SaveSettings()
	end
	
	MenuCallbackHandler.callback_horizonindicator_force_load_settings = function(self)
		HorizonIndicator:LoadSettings()
		HorizonIndicator:CreateHUD()
	end
	
	
	
	MenuCallbackHandler.callback_horizonindicator_options_close = function(item)
--		HorizonIndicator:SaveSettings()
	end
	
	HorizonIndicator:LoadSettings()
	
	MenuHelper:LoadFromJsonFile(HorizonIndicator._menu_path, HorizonIndicator, HorizonIndicator.settings)
end)

Hooks:Add("BaseNetworkSessionOnLoadComplete","horizon_indicator_createhud",callback(HorizonIndicator,HorizonIndicator,"CreateHUD"))
--Hooks:PostHook(HUDManager,"_setup_player_info_hud_pd2","horizon_indicator_createhud",callback(HorizonIndicator,HorizonIndicator,"CreateHUD"))